"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const package_name_1 = require("./package-name");
function createContainer(deep) {
    return __awaiter(this, void 0, void 0, function* () {
        const containTypeLinkId = yield deep.id("@deep-foundation/core", "Contain");
        const audioRecordsTypeLinkId = yield deep.id(package_name_1.CAPACITOR_VOICE_RECORDER_PACKAGE_NAME, "AudioRecords");
        const { data: [{ id: containerLinkId = undefined } = {}] = [] } = yield deep.select({ type_id: audioRecordsTypeLinkId });
        if (!containerLinkId) {
            const { data: [{ id: newContainerLinkId }] } = yield deep.insert({
                type_id: audioRecordsTypeLinkId,
                in: {
                    data: {
                        type_id: containTypeLinkId,
                        from_id: deep.linkId,
                        string: { data: { value: "AudioRecords" } },
                    }
                }
            });
            return newContainerLinkId;
        }
        else
            alert("Container link already exists!");
        return containerLinkId;
    });
}
exports.default = createContainer;
