"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const package_name_1 = require("./package-name");
function loadRecords(deep) {
    return __awaiter(this, void 0, void 0, function* () {
        const recordTypelinkId = yield deep.id(package_name_1.CAPACITOR_VOICE_RECORDER_PACKAGE_NAME, "Record");
        const mimetypeTypeLinkId = yield deep.id("@deep-foundation/sound", "MIME/type");
        const soundTypeLinkId = yield deep.id("@deep-foundation/sound", "Sound");
        const { data: recordLinks } = yield deep.select({
            type_id: recordTypelinkId
        });
        let records = [];
        for (let recordLink of recordLinks) {
            const { data } = yield deep.select({
                up: {
                    parent: {
                        id: recordLink.id
                    },
                    link: {
                        type_id: {
                            _in: [
                                soundTypeLinkId,
                                mimetypeTypeLinkId
                            ]
                        }
                    }
                },
            });
            const soundLink = data.filter((link) => link.type_id === soundTypeLinkId);
            const mimetypeLink = data.filter((link) => link.type_id === mimetypeTypeLinkId);
            records = [...records, { sound: soundLink[0].value.value, mimetype: mimetypeLink[0].value.value }];
        }
        return records;
    });
}
exports.default = loadRecords;
