"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const capacitor_voice_recorder_1 = require("capacitor-voice-recorder");
const upload_records_1 = __importDefault(require("./upload-records"));
function stopRecording({ deep, containerLinkId, startTime, }) {
    return __awaiter(this, void 0, void 0, function* () {
        const { value: sound } = yield capacitor_voice_recorder_1.VoiceRecorder.stopRecording();
        const endTime = new Date().toLocaleDateString();
        yield (0, upload_records_1.default)({ deep, containerLinkId, records: [{ sound, startTime, endTime }] });
        return sound;
    });
}
exports.default = stopRecording;
