"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const package_name_1 = require("./package-name");
function uploadRecords({ deep, containerLinkId, records }) {
    return __awaiter(this, void 0, void 0, function* () {
        const containTypeLinkId = yield deep.id("@deep-foundation/core", "Contain");
        const recordTypeLinkId = yield deep.id(package_name_1.CAPACITOR_VOICE_RECORDER_PACKAGE_NAME, "Record");
        const durationTypeLinkId = yield deep.id(package_name_1.CAPACITOR_VOICE_RECORDER_PACKAGE_NAME, "Duration");
        const startTimeTypeLinkId = yield deep.id(package_name_1.CAPACITOR_VOICE_RECORDER_PACKAGE_NAME, "StartTime");
        const endTimeTypeLinkId = yield deep.id(package_name_1.CAPACITOR_VOICE_RECORDER_PACKAGE_NAME, "EndTime");
        const mimetypeTypeLinkId = yield deep.id("@deep-foundation/sound", "MIME/type");
        const formatTypeLinkId = yield deep.id("@deep-foundation/sound", "Format");
        const soundTypeLinkId = yield deep.id("@deep-foundation/sound", "Sound");
        yield deep.insert(records.map((record) => ({
            type_id: recordTypeLinkId,
            in: {
                data: [{
                        type_id: containTypeLinkId,
                        from_id: containerLinkId,
                    }]
            },
            out: {
                data: [
                    {
                        type_id: containTypeLinkId,
                        to: {
                            data: {
                                type_id: soundTypeLinkId,
                                string: { data: { value: record.sound["recordDataBase64"] } },
                                out: {
                                    data: [
                                        {
                                            type_id: containTypeLinkId,
                                            to: {
                                                data: {
                                                    type_id: mimetypeTypeLinkId,
                                                    string: { data: { value: record.sound["mimeType"] } },
                                                }
                                            }
                                        },
                                        {
                                            type_id: containTypeLinkId,
                                            to: {
                                                data: {
                                                    type_id: formatTypeLinkId,
                                                    string: { data: { value: record.sound["mimeType"] === "audio/webm;codecs=opus" ? "webm" : "aac" } },
                                                }
                                            }
                                        }
                                    ]
                                }
                            }
                        }
                    },
                    {
                        type_id: containTypeLinkId,
                        to: {
                            data: {
                                type_id: durationTypeLinkId,
                                number: { data: { value: record.sound["msDuration"] } },
                            }
                        }
                    },
                    {
                        type_id: containTypeLinkId,
                        to: {
                            data: {
                                type_id: startTimeTypeLinkId,
                                string: { data: { value: record.startTime } },
                            }
                        }
                    },
                    {
                        type_id: containTypeLinkId,
                        to: {
                            data: {
                                type_id: endTimeTypeLinkId,
                                string: { data: { value: record.endTime } },
                            }
                        }
                    }
                ]
            }
        })));
    });
}
exports.default = uploadRecords;
